.8086

.MODEL large

PUBLIC wordcpy_
PUBLIC wordset_
PUBLIC wordcmp_
PUBLIC memchr_

_TEXT               SEGMENT BYTE PUBLIC USE16 'CODE'
                ASSUME CS:_TEXT                               

; dx:si = source, es:di = destination, cx = count
wordcpy_ proc near
;  push cx
  push ds
  mov ds, dx
;  push di
;  push si
  cld

  rep movsw

;  pop si
;  pop di
  pop ds
;  pop cx
  ret  
wordcpy_ endp

; es:di = destination, ax = set byte, cx = count
wordset_ proc near
;  pushf
;  push ax
;  push cx
;  push di
  cld

  shr cx, 1
  rep stosw

;  pop di
;  pop cx
;  pop ax
;  popf
  ret
wordset_ endp

; es:di, dx:si == buffers to compare
; cx = byte count
; return value to cx
wordcmp_ proc near
  push ds
;  push di
;  push si
  mov ds, dx
  cld

  repe cmpsw
  jnz memcmp_diff

  memcmp_end:
;  pop si
;  pop di
  pop ds
  ret

  memcmp_diff:
  inc cx
  jmp memcmp_end  
wordcmp_ endp

; al = chr, es:di = buffer, cx = count
memchr_ proc near
;  push cx
  cld

  repne scasb
  jz memchr_found

  xor di, di
  mov es, di
  jmp memchr_end

  memchr_found:
  dec di

  memchr_end:
;  pop cx
  ret
memchr_ endp
_TEXT ENDS

END


